;Vectors.asm
;
;Vectors - Cymbol Applet
;version 1.2
;Keith Batten

#include "cymbol.h"

#define FP_ZERO $00,$00,$FC,$00,$00,$00,$00,$00,$00,$00

dotp		equ		_textShadow + 00	; [10]
lenu		equ		_textShadow + 10	; [10]
lenv		equ		_textShadow + 20	; [10]
crossi		equ		_textShadow + 90	; [10]
crossj		equ		_textShadow + 100	; [10]
crossk		equ		_textShadow + 110	; [10]
A_addr		equ		_textShadow + 120	; [2]
B_addr		equ		_textShadow + 122	; [2]
C_addr		equ		_textShadow + 124	; [2]
D_addr		equ		_textShadow + 126	; [2]
E_addr		equ		_textShadow + 128	; [2]
F_addr		equ		_textShadow + 130	; [2]

.org $8FFE
.dw $CB07               ;identifier

; 3D Vector Multiplication (Cross Product and Dot product)
; Ai + Bj +Ck   Di + Ej +Fk
; dot = A*D+B*E+C*F
; cross = (B*F)-(C*E)i - ((A*F)-(C*D))j + (A*E)-(B*D)k
; length = sqrt(((B*F)-(C*E))^2+((A*F)-(C*D))^2+((A*E)-(B*D))^2)

        .db 6                   ;number of inputs
        .db 6                   ;selected input
        .dw applet_data         ;title bar for this applet, followed by a
                                ;routine to be run upon applet change
        ;1st input (A)
        .db %00000000           ;flags
        .dw $1100               ;x,y coordinates
input_A:
        .db FP_ZERO             ;default value
        .db 'i',0               ;any suffixes

        ;2nd input (B)
        .db %10000000           ;flags
        .dw $0000               ;x,y coordinates
input_B:
        .db FP_ZERO             ;default value
        .db 'j',0               ;any suffixes


        ;3rd input (C)
        .db %10000000           ;flags
        .dw $0000               ;x,y coordinates
input_C:
        .db FP_ZERO             ;default value
        .db 'k',0               ;any suffixes


        ;4th input (D)
        .db %00000000           ;flags
        .dw $0004               ;x,y coordinates
input_D:
        .db FP_ZERO             ;default value
        .db 'i',0               ;any suffixes


        ;5th input (E)
        .db %10000000           ;flags
        .dw $0000               ;x,y coordinates
input_E:
        .db FP_ZERO             ;default value
        .db 'j',0               ;any suffixes


        ;6th input (F)
        .db %10000000           ;flags
        .dw $0000               ;x,y coordinates
input_F:
        .db FP_ZERO             ;default value
        .db 'k',0               ;any suffixes

applet_data:
        .db " Vectors - KWB  v1.2 ",0

;lenu							; (sqrt)(A^2+B^2+C^2)
		ld hl, input_A
		call $4817				; _push_REAL_hl
		ld hl, input_B
		call $4817				; _push_REAL_hl
		ld hl, input_C
		call $4817				; _push_REAL_hl
		call length
		call _SQROOT
		ld de, lenu
		call _MOVFROP1
;lenv							; (sqrt)(D^2+E^2+F^2)
		ld hl, input_D
		call $4817				; _push_REAL_hl
		ld hl, input_E
		call $4817				; _push_REAL_hl
		ld hl, input_F
		call $4817				; _push_REAL_hl
		call length
		call _SQROOT
		ld de, lenv
		call _MOVFROP1

;Dot Product					; A*D+B*E+C*F
        ld hl,$1800
        ld (_penCol),hl

		call _OP4SET0
        ld hl,input_A           ; OP1 = A
        ld de,input_D			; OP2 = D

		call hlde_mult_add		; OP4 = A*D

        ld hl,input_B           ; OP1 = B
        ld de,input_E           ; OP2 = E

		call hlde_mult_add		; OP4 = A*D + B*E

        ld hl,input_C           ; OP1 = C
        ld de,input_F           ; OP2 = F

		call hlde_mult_add		; OP4 = A*D + B*E + C*F

		ld de, dotp
		call _MOVFROP1			; save dot product

        ld hl, dot_str
        call _vputs
        xor a
        call PrintReal			; print the dot product

;Cos ang						; dotp/(sqrt)((lenu*lenv)^2)
        ld hl,$183F
        ld (_penCol),hl

		ld hl, cos_str			; "cos (theta) ="
		call _vputs

		ld hl, lenu
		call _MOV10TOOP1		; length of u into OP1
		ld hl, lenv
		call _MOV10TOOP2		; length of v into OP2
		call _FPMULT			; lenu * lenv
		call $449B				; _ckop1fp0
		jr z, cos_disp			; if its zero just display 0
		call _FPSQUARE			; (lenu*lenv)^2
		call _OP1TOOP2
		ld hl, dotp
		call _MOV10TOOP1
		xor a
		call PrintReal			; display the dot product
		ld a, $2F				; '/'
		call _vputmap
		ld a, $10				; (sqrt)
		call _vputmap
		call _OP2TOOP1
cos_disp:
		xor a
		call PrintReal			; display (lenu*lenv)^2 or 0

;Cross Product					; (B*F-C*E)i+(C*D-A*F)j+(A*E-B*D)k
        ld hl,$1E00
        ld (_penCol),hl

		ld hl, cross_str
		call _vputs
;								; B*F-C*E
		ld hl, input_C
		call _MOV10TOOP1
		ld hl, input_E
		call _MOV10TOOP2
		call _FPMULT
		call _OP1TOOP6
		ld hl, input_B
		call _MOV10TOOP1
		ld hl, input_F
		call _MOV10TOOP2
		call _FPMULT
		call _OP6TOOP2
		call _FPSUB
		call $4813				;_push_OP1 
		xor a
		call PrintReal
		ld a, 'i'
		call _vputmap
;								; C*D-A*F
		ld hl, input_A
		call _MOV10TOOP1
		ld hl, input_F
		call _MOV10TOOP2
		call _FPMULT
		call _OP1TOOP6
		ld hl, input_C
		call _MOV10TOOP1
		ld hl, input_D
		call _MOV10TOOP2
		call _FPMULT
		call _OP6TOOP2
		call _FPSUB
		call $4813				;_push_OP1 
		ld a, %10000000
		call PrintReal
		ld a, 'j'
		call _vputmap
;								; A*E-B*D
		ld hl, input_B
		call _MOV10TOOP1
		ld hl, input_D
		call _MOV10TOOP2
		call _FPMULT
		call _OP1TOOP6
		ld hl, input_A
		call _MOV10TOOP1
		ld hl, input_E
		call _MOV10TOOP2
		call _FPMULT
		call _OP6TOOP2
		call _FPSUB
		call $4813				;_push_OP1 
		ld a, %10000000
		call PrintReal
		ld a, 'k'
		call _vputmap

lengthx:
        ld hl,$2400
        ld (_penCol),hl

		call length
		ld hl, lengthx_str
		call _vputs
		xor a
		call PrintReal

;projection
        ld hl,$2A00
        ld (_penCol),hl

		ld hl, proj_str
		call _vputs
		ld hl, lenv
		call _MOV10TOOP1
		call _FPSQUARE

		call $449B				; _ckop1fp0
		call z, _op1set1

		xor a
		call PrintReal
		ld a,')'
		call _vputmap		
		ld a,'('
		call _vputmap		

		ld hl, dotp
		call _MOV10TOOP2
		ld hl, input_D
		call _MOV10TOOP1
		call _FPMULT
		call $4813				;_push_OP1
		xor a
		call PrintReal
		ld a, 'i'
		call _vputmap

		ld hl, dotp
		call _MOV10TOOP2
		ld hl, input_E
		call _MOV10TOOP1
		call _FPMULT
		call $4813				;_push_OP1 
		ld a, %10000000
		call PrintReal
		ld a, 'j'
		call _vputmap

		ld hl, dotp
		call _MOV10TOOP2
		ld hl, input_F
		call _MOV10TOOP1
		call _FPMULT
		call $4813				;_push_OP1 
		ld a, %10000000
		call PrintReal
		ld a, 'k'
		call _vputmap
		ld a,')'
		call _vputmap		

;lengthp
        ld hl,$3000
        ld (_penCol),hl


		ld hl, lengthp_str
		call _vputs
		ld hl, lenv
		call _MOV10TOOP1
		call _FPSQUARE

		call $449B				; _ckop1fp0
		call z, _op1set1

		xor a
		call PrintReal
		ld a,')'
		call _vputmap
		ld a,$10
		call _vputmap
		call length
		xor a
		jp PrintReal

length:
		call $47B7				;_pop_OP1
		call _FPSQUARE
		call _OP1TOOP6
		call $47B7				;_pop_OP1
		call _FPSQUARE
		call _OP6TOOP2
		call _FPADD
		call _OP1TOOP6
		call $47B7				;_pop_OP1
		call _FPSQUARE
		call _OP6TOOP2
		call _FPADD
		ret

hlde_mult_add:
		push de
        rst 20h					; OP1 = hl
		pop hl
        call _MOV10TOOP2		; OP2 = de
        call _FPMULT
		call _OP4TOOP2
		call _FPADD
		call _OP1TOOP4          ; OP4 = hl * de
		ret


dot_str:
        .db "dot = ",0

cross_str:
        .db "cross = ",0

lengthx_str:
        .db "lengthx = ",$10,0

proj_str:
		.db "proj = (1/",0

lengthp_str:
        .db "lengthp = (1/",0

cos_str:
		.db	"cos ",$C1," = ",0

.end
